Package: circda
Type: Package
Title: Circular Data Analysis
Version: 1.0
Date: 2026-07-20
Authors@R: person("Michail", "Tsagris", role = c("aut", "cre"), email = "mtsagris@uoc.gr")
Author: Michail Tsagris [aut, cre]
Maintainer: Michail Tsagris <mtsagris@uoc.gr>
Depends: R (>= 4.0)
Imports: circular, Directional, graphics, rangen, Rfast, stats
Suggests: Rfast2
Description: Functions to perform maximum likelihood estimation, model-based clustering, discriminant and regression analysis with a circular response variable. <doi:10.1080/01621459.2019.1585249>.   
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2026-07-20 19:37:35 UTC; mtsag
Repository: CRAN
Date/Publication: 2026-07-29 18:30:02 UTC

circ.da <- function(unew, u, ina, rads = TRUE, type = c("vm", "cp", "pn", "gcpc", "cipc") ) {

  ina <- as.numeric(ina)
  pj <- tabulate(ina) / length(ina)
  logpj <- log(pj)
  g <- max(ina)
  if ( !rads )  u <- u * pi/180
  mat <- matrix(0, length(unew), g)
  est <- matrix(NA, nrow = length(unew), 5)
  x <- cbind( cos(u), sin(u) )
  xnew <- cbind( cos(unew), sin(unew) )

  if ( sum( type == "vm") == 1 ) {
    for ( j in 1:g ) {
      mod <- Rfast::vm.mle( u[ina == j], tol = 1e-6 )
      mat[, j] <- Directional::dvm(unew, mod$param[1], mod$param[2], rads = TRUE, logden = TRUE ) + logpj[j]
    }
    est[, 1] <- Rfast::rowMaxs(mat)
  }

  if ( sum( type == "cp") == 1 ) {
    for ( j in 1:g ) {
      mod <- Directional::purka.mle( x[ina == j, ], tol = 1e-6 )
      mat[, j] <- Directional::dcircpurka(unew, mod$circtheta, mod$alpha, rads = TRUE, logden = TRUE ) + logpj[j]
    }
    est[, 2] <- Rfast::rowMaxs(mat)
  }

  if ( sum( type == "pn") == 1 ) {
    for ( j in 1:g ) {
      mod <- Directional::spml.mle( u[ina == j], rads = TRUE, tol = 1e-6)
      mat[, j] <- Directional::dspml(unew, mod$mu, rads = TRUE, logden = TRUE ) + logpj[j]
    }
    est[, 3] <- Rfast::rowMaxs(mat)
  }

  if ( sum( type == "gcpc") == 1 ) {
    for ( j in 1:g ) {
      mod <- Directional::gcpc.mle2( u[ina == j], rads = TRUE)
      mat[, j] <- Directional::dgcpc(unew, mod$circmu, mod$gamma, mod$rho, rads = TRUE, logden = TRUE) + logpj[j]
    }
    est[, 4] <- Rfast::rowMaxs(mat)
  }

  if ( sum( type == "cipc") == 1 ) {
    for ( j in 1:g ) {
      mod <- Directional::cipc.mle( u[ina == j], rads = TRUE)
      mat[, j] <- Directional::dcipc(unew, mod$circmu, mod$gamma, rads = TRUE, logden = TRUE) + logpj[j]
    }
    est[, 5] <- Rfast::rowMaxs(mat)
  }

  colnames(est) <- c("vM", "PN", "Purka", "GCPC", "CIPC")
  est
}

rmixcirc <- function(n, rads = TRUE, probs, mu, kappa, rho, type = "vm") {

  if ( type == "vm" ) {
    mu <- cbind( cos(mu), sin(mu) )
    u <- Directional::rmixvmf(n, probs, mu, kappa)
    u$x <- ( atan(u$x[, 2]/u$x[, 1]) + pi * I(u$x[, 1] < 0) ) %% (2 * pi)
    names(u)[[ 2 ]] <- "u"
  } else if ( type == "cp" ) {
    u <- .rmixpurka(n, probs, mu, kappa)
  } else if ( type == "pn" ) {
    mu <- kappa * cbind( cos(mu), sin(mu) )
    u <- .rmixpn(n, probs, mu)
  } else if ( type == "gcpc" ) {
    u <- .rmixgcpc(n, probs, mu, kappa, rho)
  } else if ( type == "cipc" ) {
    u <- .rmixcipc(n, probs, mu, kappa)
  }
  if ( !rads )  u$u <- u$u / pi * 180
  u
}

.rmixpurka <- function(n, probs, mu, kappa) {
  p <- c( 0, cumsum(probs) )
  u <- rangen::Runif(n)
  g <- length(probs)  ## how many clusters are there
  ina <- as.numeric( cut(u, breaks = p) )  ## the cluster of each observation
  ina <- sort(ina)
  nu <- tabulate(ina)  ## frequency table of each cluster
  u <- list()
  for ( j in 1:g )  u[[ j ]] <- Directional::rcircpurka(nu[j], mu[j], kappa[j])
  u <- unlist(u)
  list(id = ina, u = u)
}


.rmixpn <- function(n, probs, mu) {
  p <- c( 0, cumsum(probs) )
  u <- rangen::Runif(n)
  g <- length(probs)  ## how many clusters are there
  ina <- as.numeric( cut(u, breaks = p) )  ## the cluster of each observation
  ina <- sort(ina)
  nu <- tabulate(ina)  ## frequency table of each cluster
  u <- list()
  for ( j in 1:g )  u[[ j ]] <- Directional::rspml(nu[j], mu[j, ])
  u <- unlist(u)
  list(id = ina, u = u)
}

.rmixgcpc <- function(n, probs, mu, kappa, rho) {
  p <- c( 0, cumsum(probs) )
  u <- rangen::Runif(n)
  g <- length(probs)  ## how many clusters are there
  ina <- as.numeric( cut(u, breaks = p) )  ## the cluster of each observation
  ina <- sort(ina)
  nu <- tabulate(ina)  ## frequency table of each cluster
  u <- list()
  for ( j in 1:g )  u[[ j ]] <- Directional::rgcpc(nu[j], omega = mu[j], g = kappa[j], rho = rho[j])
  u <- unlist(u)
  list(id = ina, u = u)
}

.rmixcipc <- function(n, probs, mu, kappa) {
  p <- c( 0, cumsum(probs) )
  u <- rangen::Runif(n)
  g <- length(probs)  ## how many clusters are there
  ina <- as.numeric( cut(u, breaks = p) )  ## the cluster of each observation
  ina <- sort(ina)
  nu <- tabulate(ina)  ## frequency table of each cluster
  u <- list()
  for ( j in 1:g )  u[[ j ]] <- Directional::rcipc(nu[j], omega = mu[j], g = kappa[j])
  u <- unlist(u)
  list(id = ina, u = u)
}

circ.reg <- function(y, x, rads = TRUE, type = "vm", xnew = NULL, tol = 1e-6, maxiters = 100) {

  if ( !is.matrix(y) ) {
    if ( !rads )  y <- y * pi / 180
    y <- cbind( cos(y), sin(y) )
  }

  if ( type == "vm" ) {
    res <- .vm.reg(y = y, x = x, rads = rads, xnew = xnew, tol = tol, maxiters = maxiters)
  } else if ( type == "cp" ) {
    res <- Directional::circpurka.reg(y = y, x = x, rads = rads, xnew = xnew)
  } else if ( type == "pn" ) {
    res <- Directional::spml.reg(y = y, x = x, rads = rads, xnew = xnew, seb = TRUE, tol = tol, maxiters = maxiters)
  } else if ( type == "gcpc" ) {
    res <- Directional::gcpc.reg(y = y, x = x, rads = rads, xnew = xnew)
  } else if ( type == "cipc" ) {
    res <- Directional::cipc.reg(y = y, x = x, rads = rads, xnew = xnew, tol = tol, maxiters = maxiters)
  }
  res
}



.vm.reg <- function(y, x, rads = TRUE, xnew = NULL, tol = 1e-6, maxiters = 100) {

  tic <- proc.time()

  x <- model.matrix( ~., data.frame(x) )
  dm <- dim(x)
  n <- dm[1]  ;  p <- dm[2] - 1

  be <- solve( crossprod(x), crossprod(x, y) )  ## initial values for the beta
  mu <- x %*% be
  ki <- sqrt( Rfast::rowsums(mu^2) )
  lik1 <- sum(mu * y) - sum( log(besselI(ki, 0, expon.scaled = TRUE) ) + ki )

  A1  <- besselI(ki, 1) / besselI(ki, 0)                  ## n
  A1d <- 1 - A1 / ki - A1^2                               ## A'_1(kappa), n
  ## --- gradient: p x 2 ---
  resid <- y - (A1 / ki) * mu                             ## n x 2
  grad <- crossprod(x, resid)                            ## p x 2
  ## --- Hessian weights ---
  mu_ki  <- mu / ki                                       ## n x 2, unit vectors
  d11 <- A1d * mu_ki[, 1]^2 + (A1 / ki) * (1 - mu_ki[, 1]^2)
  d22 <- A1d * mu_ki[, 2]^2 + (A1 / ki) * (1 - mu_ki[, 2]^2)
  d12 <- (A1d - A1/ki) * mu_ki[, 1] * mu_ki[, 2]
  ## --- Hessian blocks: each is p x p ---
  H11 <-  -crossprod(x * d11, x)
  H22 <-  -crossprod(x * d22, x)
  H12 <-  -crossprod(x * d12, x)
  ## --- full 2p x 2p Hessian ---
  H <- rbind( cbind(H11, H12), cbind(H12, H22) )

  be <- be - solve(H, as.vector(grad) )
  be <- matrix(be, ncol = 2)
  mu <- x %*% be
  ki <- sqrt( Rfast::rowsums(mu^2) )
  lik2 <- sum(mu * y) - sum( log(besselI(ki, 0, expon.scaled = TRUE) ) + ki )

  i <- 2
  while ( lik2 - lik1 > tol  &  i < maxiters ) {
    i <- i + 1
    lik1 <- lik2

    A1  <- besselI(ki, 1) / besselI(ki, 0)                  ## n
    A1d <- 1 - A1 / ki - A1^2                               ## A'_1(kappa), n
    ## --- gradient: p x 2 ---
    resid <- y - (A1 / ki) * mu                             ## n x 2
    grad <- crossprod(x, resid)                            ## p x 2
    ## --- Hessian weights ---
    mu_ki  <- mu / ki                                       ## n x 2, unit vectors
    d11 <- A1d * mu_ki[, 1]^2 + (A1 / ki) * (1 - mu_ki[, 1]^2)
    d22 <- A1d * mu_ki[, 2]^2 + (A1 / ki) * (1 - mu_ki[, 2]^2)
    d12 <- (A1d - A1/ki) * mu_ki[, 1] * mu_ki[, 2]
    ## --- Hessian blocks: each is p x p ---
    H11 <-  -crossprod(x * d11, x)
    H22 <-  -crossprod(x * d22, x)
    H12 <-  -crossprod(x * d12, x)
    ## --- full 2p x 2p Hessian ---
    H <- rbind( cbind(H11, H12), cbind(H12, H22) )

    be <- be - solve(H, as.vector(grad) )
    be <- matrix(be, ncol = 2)
    mu <- x %*% be
    ki <- sqrt( Rfast::rowsums(mu^2) )
    lik2 <- sum(mu * y) - sum( log(besselI(ki, 0, expon.scaled = TRUE) ) + ki )
  }

  runtime <- proc.time() - tic

  est <- NULL
  if ( !is.null(xnew) ) {
    xnew <- model.matrix(~., data.frame(xnew))
    est <- xnew %*% be
    est <- ( atan(est[, 2]/est[, 1]) + pi * I(est[, 1] < 0) ) %% (2 * pi)
    if ( !rads )  est <- est * 180 / pi
  }

  seb <- sqrt( - diag( solve(H) ) )
  seb <- matrix(seb, ncol = 2)
  colnames(be) <- colnames(seb) <- c("Cosinus of y", "Sinus of y")
  rownames(be) <- rownames(seb) <- colnames(x)

  loglik <- lik2 - n * log(2 * pi)

  list(runtime = runtime, be = be, seb = seb, loglik = loglik, ki = ki, est = est)

}

circ.regs <- function(y, x, rads = TRUE, type = "vm", tol = 1e-6, logged = FALSE, maxiters = 100, ncores = 1) {

  if ( !is.matrix(y) ) {
    if ( !rads )  y <- y * pi / 180
    y <- cbind( cos(y), sin(y) )
  }

  if ( type == "pn" ) {
    parallel <- FALSE
    if  ( ncores > 1 )  parallel <- TRUE
    res <- Directional::spml.regs(y = y, x = x, tol = tol, logged = logged, maxiters = maxiters, parallel = parallel )

  } else {
    if ( type == "vm" ) {
      lik0 <- Rfast::vmf.mle(y, tol = tol)$loglik
      lik <- .vm.regs(y = y, x = x, tol = tol, maxiters = maxiters)
      stat <- 2 * (lik - lik0)
    } else if ( type == "cp" ) {
      lik0 <- Directional::purka.mle(y, tol = tol)$loglik
      lik <- .cp.regs(y = y, x = x)
      stat <- 2 * (lik - lik0)
    } else if ( type == "cipc" ) {
      y1 <- ( atan(y[, 2]/y[, 1]) + pi * I(y[, 1] < 0) ) %% (2 * pi)
      lik0 <- Directional::cipc.mle(y1, rads = TRUE, tol = tol)$loglik
      lik <- .cipc.regs(y = y, x = x, tol = tol, maxiters = maxiters)
      stat <- 2 * (lik - lik0)
    }
    pvalue <- pchisq(stat, 2, lower.tail = FALSE, log.p = logged)
    res <- cbind(stat, pvalue)
    colnames(res) <- c("stat", "p-value")
  }

  res
}



.vm.regs <- function(y = y, x = x, tol = tol, maxiters = maxiters, ncores = 1) {

  p <- dim(x)[2]
  stat <- numeric(p)

  if ( ncores <= 1 ) {
    for ( j in 1:p )  stat[j] <- .vm.reg(y, x[, j], tol = tol, maxiters = maxiters)$loglik
  } else {
    cl <- parallel::makeCluster(ncores)
    parallel::clusterExport(cl, varlist = c("y", "x", "tol", "maxiters", ".vm.reg"), envir = environment())
    stat <- parallel::parSapply(cl, 1:p, function(j) {
      .vm.reg(y, x[, j], tol = tol, maxiters = maxiters)$loglik
    })
    parallel::stopCluster(cl)
  }
  stat
}


.cp.regs <- function(y = y, x = x, tol = tol, maxiters = maxiters, ncores = 1) {

  p <- dim(x)[2]
  stat <- numeric(p)

  if ( ncores <= 1 ) {
    for ( j in 1:p )  stat[j] <- Directional::circpurka.reg(y, x[, j], tol = tol, maxiters = maxiters)$loglik
  } else {
    cl <- parallel::makeCluster(ncores)
    parallel::clusterEvalQ(cl, library(Directional) )
    parallel::clusterExport(cl, varlist = c("y", "x", "tol", "maxiters"), envir = environment())
    stat <- parallel::parSapply(cl, 1:p, function(j) {
      Directional::circpurka.reg(y, x[, j], tol = tol, maxiters = maxiters)$loglik
    })
    parallel::stopCluster(cl)
  }
  stat
}


.cipc.regs <- function(y = y, x = x, rads = rads, xnew = xnew, tol = tol, maxiters = maxiters, ncores = 1) {

  p <- dim(x)[2]
  stat <- numeric(p)

  if ( ncores <= 1 ) {
    for ( j in 1:p )  stat[j] <- Directional::cipc.reg(y, x[, j], tol = tol, maxiters = maxiters)$loglik
  } else {
    cl <- parallel::makeCluster(ncores)
    parallel::clusterEvalQ(cl, library(Directional) )
    parallel::clusterExport(cl, varlist = c("y", "x", "tol", "maxiters"), envir = environment())
    stat <- parallel::parSapply(cl, 1:p, function(j) {
      Directional::cipc.reg(y, x[, j], tol = tol, maxiters = maxiters)$loglik
    })
    parallel::stopCluster(cl)
  }
  stat
}

dmixcirc <- function(u, rads = TRUE, probs, mu, kappa, rho, type = "vm", logden = FALSE) {

  g <- length(probs)
  den <- matrix(nrow = length(u), ncol = g)

  if ( type == "vm" ) {
    for ( j in 1:g )  den[, j] <- Directional::dvm(u, mu[j], kappa[j], rads = rads)
  } else if ( type == "cp" ) {
    for ( j in 1:g )  den[, j] <- Directional::dcircpurka(u, mu[j], kappa[j], rads = rads)
  } else if ( type == "pn" ) {
    for ( j in 1:g )  den[, j] <- Directional::dspml(u, kappa[j] * mu[j], rads = rads)
  } else if ( type == "gcpc" ) {
    for ( j in 1:g )  den[, j] <- Directional::dgcpc(u, omega = mu[j], g = kappa[j],
                                                     rho = rho[j], rads = rads)
  } else if ( type == "cipc" ) {
    for ( j in 1:g )  den[, j] <- Directional::dcipc(u, omega = mu[j], g = kappa[j], rads = rads)
  }

  den <- den %*% probs
  if ( logden )  den <- log(den)
  den
}

circplot <- function(u, mu  = NULL, rads = TRUE, col = 3, lwd = 2) {
  if ( !rads )  u <- u * pi / 180
  dat <- circular::circular(u)
  plot(dat, stack = TRUE)
  if ( is.null(mu) ) {
    cx <- mean( cos(u) )  ;  cy <- mean( sin(u) )
    mu <- ( atan(cy/cx) + pi * I(cx < 0) ) %% (2 * pi)
    cx <- cos(mu)  ;  cy <- sin(mu)
  } else {
    cx <- cos(mu)
    cy <- sin(mu)
  }
  arrows(x0 = 0, y0 = 0, x1 = cx, y1 = cy, length = 0.10, lwd = lwd, col = col)
}

mixcirc.mle <- function(u, type = "vm", rads = TRUE, g = 2, tol = 1e-4, maxiters = 500) {

  if ( type == "vm" ) {
    res <- .mixvm.mle(u, rads, g, tol, maxiters)
    mu <- res$param[, 3:4]
    mu <- ( atan(mu[, 2]/mu[, 1]) + pi * I(mu[, 1] < 0) ) %% (2 * pi)
    res$param <- cbind( res$param[, 1], mu, res$param[, 2] )
    colnames(res$param) <- c("probs", "mu", "kappa")
  } else if ( type == "cp" ) {
    res <- .mixpurka.mle(u, rads, g, tol, maxiters)
    mu <- res$param[, 2:3]
    mu <- ( atan(mu[, 2]/mu[, 1]) + pi * I(mu[, 1] < 0) ) %% (2 * pi)
    res$param <- cbind( res$param[, 1], mu, res$param[, 4] )
    colnames(res$param) <- c("probs", "theta", "alpha")
  } else if ( type == "pn" ) {
    res <- .mixpn.mle(u, rads, g, tol, maxiters)
    mu <- res$param[, 2:3]
    mu <- ( atan(mu[, 2]/mu[, 1]) + pi * I(mu[, 1] < 0) ) %% (2 * pi)
    res$param <- cbind( res$param[, 1], mu, res$param[, 4] )
    colnames(res$param) <- c("probs", "mu", "gamma")
  } else if ( type == "gcpc" ) {
    res <- .mixgcpc.mle(u, rads, g, tol, maxiters)
  } else if ( type == "cipc" ) {
    res <- .mixcipc.mle(u, rads, g, tol, maxiters)
    mu <- res$param[, 3:4]
    mu <- ( atan(mu[, 2]/mu[, 1]) + pi * I(mu[, 1] < 0) ) %% (2 * pi)
    res$param <- cbind( res$param[, 1], mu, res$param[, 2] )
    colnames(res$param) <- c( "probs", "omega", "gamma")
  }
  res
}


.mixvm.mle <- function(u, rads = TRUE, g = 2, tol = 1e-4, maxiters = 100) {

  if ( ! rads )  u <- u * pi / 180
  x <- cbind( cos(u), sin(u) )
  res <- Directional::mixvmf.mle(x, g, n.start = 10, tol = tol, maxiters = maxiters)
  names(res)[[ 4 ]] <- "probs"
  res
}


.mixcipc.mle <- function(u, rads = TRUE, g = 2, tol = 1e-4, maxiters = 100) {

  if ( ! rads )  u <- u * pi / 180
  x <- cbind( cos(u), sin(u) )
  res <- Directional::mixspcauchy.mle(x, g, n.start = 10, tol = tol, maxiters = maxiters)
  names(res)[[ 5 ]] <- "probs"
  res
}


.mixpurka.mle <- function(u, rads = TRUE, g = 2, tol = 1e-4, maxiters = 100) {

  fun2 <- function(wlika, rswlika, x, g, param, lika) {

    wij <- wlika / rswlika  ## weights
    pj <- Rfast::colmeans(wij)   # PANOS

    for ( j in 1:g ) {
      mod <- .wpurka.mle(x, w = wij[, j])
      theta <- mod$theta
      a <- mod$alpha
      param[j, ] <- c(theta, a)
      v <- drop(x %*% theta)
      v <- pmin(pmax(v, -1), 1)
      lika[, j] <- log(a) - log( 1 - exp(-a * pi) ) - a * acos(v) + log( pj[j] )
    }

    wlika <- exp(lika) 		#PANOS
    rswlika <- Rfast::rowsums(wlika) #PANOS
    lik <- sum( log( rswlika ) ) 	#PANOS
    wij <- wlika / rswlika
    list(wij = wij, param = param, wlika = wlika, rswlika = rswlika, lika = lika, lik = lik)
  }

  if ( !rads )  u <- u * pi / 180
  x <- cbind( cos(u), sin(u) )
  n <- dim(x)[1]

  lik <- NULL
  lika <- matrix(nrow = n, ncol = g)
  param <- matrix(nrow = g, ncol = 3)

  runtime <- proc.time()
  ## Step 1

  if ( g > 1 ) {
    cl <- kmeans(x, g, nstart = 10)$cl

  } else  cl <- rep(1, n)
  wij <- tabulate(cl)

  while ( min(wij) <= 6 ) {
    g <- g - 1
    lika <- matrix(nrow = n, ncol = g)
    param <- matrix(nrow = g, ncol = 3)
    cl <- kmeans(x, g, nstart = 10)$cl
    wij <- tabulate(cl)
  }

  for ( j in 1:g ) {
    mod <- Directional::purka.mle(x[cl == j, ])
    theta <- mod$theta
    a <- mod$alpha
    param[j, ] <- c(theta, a)
    v <- drop(x %*% theta)
    v <- pmin(pmax(v, -1), 1) 
    lika[, j] <- log(a) - log(1 - exp(-a * pi)) - a * acos(v)
  }

  wlika <- exp(lika)
  rswlika <- Rfast::rowsums(wlika)

  ep <- fun2(wlika, rswlika, x, g, param, lika)
  lik[1] <- ep$lik
  ep2 <- fun2(ep$wlika, ep$rswlika, x, g, ep$param, ep$lika)
  lik[2] <- ep2$lik

  i <- 2
  while ( abs(lik[i] - lik[i - 1] ) > tol & i < maxiters ) {
    i <- i + 1
    ep <- ep2
    ep2 <- fun2(ep$wlika, ep$rswlika, x, g, ep$param, ep$lika)
    lik[i] <- ep2$lik
  }
  res <- ep2
  if ( ep$lik > ep2$lik )  res <- ep

  pj <- Rfast::colmeans(res$wij)
  probs <- res$wij
  loglik <- res$lik
  ta <- Rfast::rowMaxs(res$wij)  ## estimated cluster of each observation
  param <- cbind(pj, res$param)
  colnames(param) <- c( "probs", paste("theta", 1:2, sep = ""), "alpha" )
  rownames(param) <- paste("Cluster", 1:g, sep = " ")

  runtime <- proc.time() - runtime
  list( param = param, loglik = loglik - n * log(2),
        pred = ta, probs = probs, iters = i, runtime = runtime )
}



.wpurka.mle <- function(x, w = NULL, tol = 1e-07) {
  n <- dim(x)[1]
  sw <- sum(w)
  eps <- 1e-6

  theta <- Rfast::mediandir(x)  # unweighted start
  for ( iter in 1:500 ) {
    ct <- drop(x %*% theta)
    ct <- pmin(pmax(ct, -1 + eps), 1 - eps)   # keep away from +/-1
    d <- pmax(acos(ct), eps)
    wts <- w / d
    g <- Rfast::eachcol.apply(x, wts)
    g_norm  <- sqrt( sum(g^2) )
    if ( g_norm < eps ) break          # already at a Weiszfeld fixed point
    theta_new <- g / g_norm
    if ( sqrt( sum( (theta_new - theta)^2 ) ) < tol ) {
      theta <- theta_new
      break
    }
    theta <- theta_new
  }

  a <- drop(x %*% theta)
  a[ is.na(a) ] <- 0
  a <- pmin(pmax(a, -1), 1)
  A <- sum( w * acos(a) )           # WEIGHTED sum of geodesic distances
  circle <- function(a, A, sw)  sw * log(a) - sw * log( 1 - exp(-a * pi) ) - a * A

  lika <- optimize(circle, c(0.001, 1000), maximum = TRUE, A = A, sw = sw, tol = tol)
  list(theta = theta, alpha = lika$maximum, loglik = lika$objective - sw * log(2) )
}


.mixpn.mle <- function(u, rads = TRUE, g = 2, tol = 1e-4, maxiters = 100) {

  fun2 <- function(wlika, rswlika, x, g, param, lika) {

    wij <- wlika / rswlika  ## weights
    pj <- Rfast::colmeans(wij)   # PANOS
    f <-  - 0.5   ;   con <- sqrt(2 * pi)

    for ( j in 1:g ) {
      mod <- .wpn.mle(u, w = wij[, j])
      mu <- drop(mod$mu)
      gam <- sum(mu^2)
      tau <- drop( x %*% mu )
      ptau <- pnorm(tau)
      param[j, ] <- c(mu, sqrt(gam) )
      lika[, j] <-  - 0.5 * gam + log1p( tau * ptau * con / exp(f * tau^2) ) + log( pj[j] )
    }

    wlika <- exp(lika) 		#PANOS
    rswlika <- Rfast::rowsums(wlika) #PANOS
    lik <- sum( log( rswlika ) ) 	#PANOS
    wij <- wlika / rswlika
    list(wij = wij, param = param, wlika = wlika, rswlika = rswlika, lika = lika, lik = lik)
  }

  if ( ! rads )  u <- u * pi / 180
  x <- cbind( cos(u), sin(u) )
  n <- dim(x)[1]
  lik <- NULL
  lika <- matrix(nrow = n, ncol = g)
  param <- matrix(nrow = g, ncol = 3)

  runtime <- proc.time()
  ## Step 1

  if ( g > 1 ) {
    cl <- kmeans(x, g, nstart = 10)$cl

  } else  cl <- rep(1, n)
  wij <- tabulate(cl)

  while ( min(wij) <= 6 ) {
    g <- g - 1
    lika <- matrix(nrow = n, ncol = g)
    param <- matrix(nrow = g, ncol = 3)
    cl <- kmeans(x, g, nstart = 10)$cl
    wij <- tabulate(cl)
  }

  f <-  - 0.5   ;   con <- sqrt(2 * pi)
  for ( j in 1:g ) {
    mod <- Directional::spml.mle(u[cl == j], rads = TRUE)
    mu <- drop(mod$mu)
    gam <- sum(mu^2)
    tau <- drop( x %*% mu )
    ptau <- pnorm(tau)
    param[j, ] <- c( mu, sqrt(gam) )
    lika[, j] <- - 0.5 * gam + log1p( tau * ptau * con / exp(f * tau^2) )
  }

  wlika <- exp(lika)
  rswlika <- Rfast::rowsums(wlika)

  RES <- try({
    ep <- fun2(wlika, rswlika, x, g, param, lika)
    lik[1] <- ep$lik
    ep2 <- fun2(ep$wlika, ep$rswlika, x, g, ep$param, ep$lika)
    lik[2] <- ep2$lik

    i <- 2
    while ( lik[i] - lik[i - 1] > tol & i < maxiters ) {
      i <- i + 1
      ep <- ep2
      ep2 <- fun2(ep$wlika, ep$rswlika, x, g, ep$param, ep$lika)
      lik[i] <- ep2$lik
    }
    res <- ep2
    if ( ep$lik > ep2$lik )  res <- ep
  }, silent = TRUE)

  if ( !identical(class(RES), "try-error") ) {
    probs <- res$wij
    pj <- Rfast::colmeans(probs)
    loglik <- res$lik
    ta <- Rfast::rowMaxs(res$wij)  ## estimated cluster of each observation
    param <- cbind(pj, res$param)
    colnames(param) <- c( "probs", paste("mu", 1:2, sep = ""), "gamma" )
    rownames(param) <- paste("Cluster", 1:g, sep = " ")
  } else  pj <- loglik <- ta <- param <- probs <- iters <- NA

  runtime <- proc.time() - runtime
  list( param = param, loglik = loglik - n * log(2 * pi),
        pred = ta, probs = probs, iters = i, runtime = runtime )
}


#### Projected multivariate normal MLE (weighted version)
#### Presnell, Morrison and Littell (1998), JASA
################################
.wpn.mle <- function(u, w = NULL, tol = 1e-09) {
  ci <- cos(u)  ;   si <- sin(u)
  x <- cbind(ci, si)  ## bring the data onto the circle
  n <- dim(x)[1]

  if ( is.null(w) )   w <- rep(1, n)
  sw <- sum(w)

  ini <- Rfast::vmf.mle(x)  ## weighted vMF starting values
  mu1 <- ini$mu * ini$kappa
  f <-  - 0.5   ;   con <- sqrt(2 * pi)
  tau <- drop( x %*% mu1 )
  ptau <- pnorm(tau)
  rat <- ptau / ( exp(f * tau^2)/con + tau * ptau )
  psit <- tau + rat
  psit2 <- 2 - tau * rat - rat^2
  der <- Rfast::eachcol.apply(x, w * psit) - sw * mu1
  dera <- der[1]   ;  derb <- der[2]
  dera2 <- sum( w * (psit2 * ci^2 - 1) )
  derab <- sum( w * psit2 * ci * si )
  derb2 <- sum( w * (psit2 * si^2 - 1) )
  mu2 <- mu1 - c( derb2 * dera - derab * derb, - derab * dera + dera2 * derb ) / ( dera2 * derb2 - derab^2 )

  i <- 2
  while ( sum( abs(mu2 - mu1) ) > tol ) {
    i <- i + 1
    mu1 <- mu2
    tau <- drop( x %*% mu1 )
    ptau <- pnorm(tau)
    rat <- ptau / ( exp(f * tau^2)/con + tau * ptau )
    psit <- tau + rat
    psit2 <- 2 - tau * rat - rat^2
    der <- Rfast::eachcol.apply(x, w * psit) - sw * mu1
    dera <- der[1]   ;  derb <- der[2]
    dera2 <- sum( w * (psit2 * ci^2 - 1) )
    derab <- sum( w * psit2 * ci * si )
    derb2 <- sum( w * (psit2 * si^2 - 1) )
    mu2 <- mu1 - c( derb2 * dera - derab * derb, - derab * dera + dera2 * derb ) / ( dera2 * derb2 - derab^2 )
  }
  gam <- sum(mu2^2)
  loglik <-  - 0.5 * sw * gam + sum( w * log1p( tau * ptau * con / exp(f * tau^2) ) ) - sw * log(2 * pi)
  list(iters = i, loglik = loglik, gamma = gam, mu = mu2)
}


.mixgcpc.mle <- function(u, rads = TRUE, g = 2, tol = 1e-4, maxiters = 100) {

  fun2 <- function(wlika, rswlika, u, g, param, lika) {

    wij <- wlika / rswlika  ## weights
    pj <- Rfast::colmeans(wij)   # PANOS

    for ( j in 1:g ) {
      mod <- .wgcpc.mle2(u, w = wij[, j])
      mod1 <- .wgcpc.mle(u, w = wij[, j])
      if ( mod1$loglik > mod$loglik )  mod <- mod1
      omega <- mod$circmu
      gam <- mod$gamma
      rho <- mod$rho
      param[j, ] <- c(omega, gam, rho)
      phi <- u - omega
      a <- gam * cos(phi)
      b <- cos(phi)^2 + sin(phi)^2/rho
      lika[, j] <- 0.5 * log(rho) + log( b * sqrt(gam^2 + 1) - a * sqrt(b) ) + log( pj[j] )
    }

    wlika <- exp(lika) 		#PANOS
    rswlika <- Rfast::rowsums(wlika) #PANOS
    lik <- sum( log( rswlika ) ) 	#PANOS
    wij <- wlika / rswlika
    list(wij = wij, param = param, wlika = wlika, rswlika = rswlika, lika = lika, lik = lik)
  }

  if ( !rads )  u <- u * pi / 180
  n <- length(u)

  lik <- NULL
  lika <- matrix(nrow = n, ncol = g)
  param <- matrix(nrow = g, ncol = 3)

  runtime <- proc.time()
  ## Step 1

  if ( g > 1 ) {
    x <- cbind( cos(u), sin(u) )
    cl <- kmeans(x, g, nstart = 10)$cl
  } else  cl <- rep(1, n)
  wij <- tabulate(cl)

  while ( min(wij) <= 6 ) {
    g <- g - 1
    lika <- matrix(nrow = n, ncol = g)
    param <- matrix(nrow = g, ncol = 3)
    cl <- kmeans(x, g, nstart = 10)$cl
    wij <- tabulate(cl)
  }

  for ( j in 1:g ) {
    mod <- Directional::gcpc.mle2(u[cl == j], rads = TRUE)
    mod1 <- Directional::gcpc.mle(u[cl == j], rads = TRUE)
    if ( mod1$loglik > mod$loglik )  mod <- mod1
    omega <- mod$circmu
    gam <- mod$gamma
    rho <- mod$rho
    param[j, ] <- c(omega, gam, rho)
    phi <- u - omega
    a <- gam * cos(phi)
    b <- cos(phi)^2 + sin(phi)^2/rho
    lika[, j] <- 0.5 * log(rho) + log( b * sqrt(gam^2 + 1) - a * sqrt(b) )
  }

  wlika <- exp(lika)
  rswlika <- Rfast::rowsums(wlika)

  ep <- fun2(wlika, rswlika, u, g, param, lika)
  lik[1] <- ep$lik
  ep2 <- fun2(ep$wlika, ep$rswlika, u, g, ep$param, ep$lika)
  lik[2] <- ep2$lik

  i <- 2
  while ( lik[i] - lik[i - 1] > tol & i < maxiters ) {
    i <- i + 1
    ep <- ep2
    ep2 <- fun2(ep$wlika, ep$rswlika, u, g, ep$param, ep$lika)
    lik[i] <- ep2$lik
  }
  res <- ep2
  if ( ep$lik > ep2$lik )  res <- ep

  pj <- Rfast::colmeans(res$wij)
  loglik <- res$lik
  ta <- Rfast::rowMaxs(res$wij)  ## estimated cluster of each observation
  param <- cbind(pj, res$param)
  runtime <- proc.time() - runtime
  colnames(param) <- c( "probs", "omega", "gamma", "rho" )
  rownames(param) <- paste("Cluster", 1:g, sep = " ")

  list( param = param, loglik = loglik - n * log(2 * pi),
        pred = ta, probs = res$wij, iters = i, runtime = runtime )
}



.wgcpc.mle2 <- function(u, w) {
  lik <- function(para, u, w, sw) {
    omega <- para[1]
    r <- max(exp(para[2]), 1000)  ;  g <- max(exp(para[3]), 1000)
    phi <- u - omega
    a <- g * cos(phi)
    b <- cos(phi)^2 + sin(phi)^2/r
    0.5 * sw * log(r) + sum( w * log( b * sqrt(g^2 + 1) - a * sqrt(b) ) )
  }

  n <- length(u)
  sw <- sum(w)
  mod <- Directional::cipc.mle(u, TRUE)
  suppressWarnings({
    ini <- c(mod$mu, log( mod$gamma^2), rnorm(1) )
    mod <- optim(ini, lik, u = u, w = w, sw = sw, control = list(maxit = 5000))
    mod <- optim(mod$par, lik, u = u, w = w, sw = sw, control = list(maxit = 5000))
    mod <- optim(mod$par, lik, u = u, w = w, sw = sw, control = list(maxit = 5000))
  })
  circmu <- mod$par[1] %% (2 *pi)
  rho <- exp(mod$par[2])  ;  gama <- exp(mod$par[3])
  mu <- c( cos(circmu), sin(circmu) ) * gama
  list(mu = mu, circmu = circmu, gamma = gama, rho = rho, loglik = -mod$value - n * log(2 * pi) )
}


.wgcpc.mle <- function(x, w = NULL) {
  likint <- function(mu, rho, x, w, sw) {
    g2 <- sum(mu^2)
    ksi <- mu / sqrt(g2)
    sinv <- matrix( c( ksi[1]^2 + ksi[2]^2/rho, ksi[1] * ksi[2] * (1 - 1/rho),
                       ksi[1] * ksi[2] * (1 - 1/rho), ksi[2]^2 + ksi[1]^2/rho ), ncol = 2 )
    a <- as.vector(x %*% mu)
    b <- Rfast::rowsums( x %*% sinv * x )
    sw * 0.5 * log(rho) + sum( w * log( b * sqrt(g2 + 1) - a * sqrt(b) ) )
  }
  lik0 <- function(rho, x, w, sw, ma) {
    m1 <- optim(ma, likint, rho = rho, x = x, w = w, sw = sw, control = list(maxit = 1000) )
    - optim( m1$par, likint, rho = rho, x = x, w = w, sw = sw, control = list(maxit = 1000) )$value
  }
  lik <- function(param, x, w, sw) {
    mu <- param[1:2]
    rho <- param[3]
    g2 <- sum(mu^2)
    ksi <- mu / sqrt(g2)
    sinv <- matrix( c( ksi[1]^2 + ksi[2]^2/rho, ksi[1] * ksi[2] * (1 - 1/rho),
                       ksi[1] * ksi[2] * (1 - 1/rho), ksi[2]^2 + ksi[1]^2/rho ), ncol = 2 )
    a <- drop(x %*% mu)
    b <- Rfast::rowsums( x %*% sinv * x )
    sw * 0.5 * log(rho) + sum( w * log( b * sqrt(g2 + 1) - a * sqrt(b) ) )
  }

  x <- cbind( cos(x), sin(x) )
  n <- dim(x)[1]
  sw <- sum(w)

  ma <- Rfast::eachcol.apply(x, w) / sw      # weighted resultant vector as starting mu

  rho <- optimize(lik0, c(0.001, 1000), x = x, w = w, sw = sw, ma = ma, maximum = TRUE)$maximum
  mod <- optim(ma, likint, rho = rho, x = x, w = w, sw = sw, control = list(maxit = 5000) )
  suppressWarnings({
    mod <- optim( c(mod$par, rho), lik, x = x, w = w, sw = sw, control = list(maxit = 5000) )
  })
  mu <- mod$par[1:2]  ;  rho = mod$par[3]
  gama <- sqrt( sum(mu^2) )
  circmu <- ( atan(mu[2]/mu[1]) + pi * I(mu[1] < 0) ) %% (2 * pi)
  list(mu = mu, circmu = circmu, gamma = gama, rho = rho,
       loglik = -mod$value - sw * log(2 * pi) )
}

rcirc <- function(n, rads = TRUE, mu, kappa, rho, type = "vm") {

  if ( type == "vm" ) {
    u <- Directional::rvonmises(n, mu, kappa, rads = TRUE)
  } else if ( type == "cp" ) {
    u <- Directional::rcircpurka(n, mu, kappa, rads = TRUE)
  } else if ( type == "pn" ) {
    mu <- kappa * cbind( cos(mu), sin(mu) )
    u <- Directional::rspml(n, mu, rads = TRUE)
  } else if ( type == "gcpc" ) {
    u <- Directional::rgcpc(n, omega = mu, g = kappa, rho = rho, rads = TRUE)
  } else if ( type == "cipc" ) {
    u <- Directional::rcipc(n, omega = mu, g = kappa, rads = TRUE)
  }
  if ( !rads )  u <- u / pi * 180
  u
}

colcirc.mle <- function(u, rads = TRUE, type = "vm", tol = 1e-07, maxiters = 100, parallel = FALSE) {

  if ( !rads )  u <- u * pi / 180

  if ( type == "vm" ) {
    res <- Rfast::colvm.mle(u, tol = tol)
  } else if ( type == "spml" ) {
    res <- Rfast2::colspml.mle(u, tol = tol, maxiters = maxiters, parallel = parallel)
  } else if ( type == "cp" ) {
    res <- .colpurka.mle(u, tol = tol)
  } else if ( type == "cipc" ) {
    res <- .colcipc.mle(u, tol = tol)
  } else if ( type == "gcpc" ) {
    res <- .colgcpc.mle(u)
  }

  res
}



.colpurka.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 5)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Rfast2::purka.mle(x[, i]) )
  colnames(res) <- c("theta1", "theta2", "alpha", "loglik", "alpha.sd")
  res
}


.colgcpc.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 6)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Directional::gcpc.mle(x[, i], rads = TRUE) )
  colnames(res) <- c("mu1", "mu2", "circmu", "gamma", "rho", "loglik")
  res
}


.colcipc.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 5)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Directional::cipc.mle(x[, i], rads = TRUE, tol = tol) )
  colnames(res) <- c("mu1", "mu2", "circmu", "gamma", "loglik")
  res
}

dcirc <- function(u, rads = TRUE, mu, kappa, rho, type = "vm", logden = FALSE) {

  if ( type == "vm" ) {
    den <- Directional::dvm(u, mu, kappa, rads = rads, logden = logden)
  } else if ( type == "cp" ) {
    den <- Directional::dcircpurka(u, mu, kappa, rads = rads, logden = logden)
  } else if ( type == "pn" ) {
    mu <- kappa * c( cos(mu), sin(mu) )
    den <- Directional::dspml(u, mu, rads = rads, logden = logden)
  } else if ( type == "gcpc" ) {
    den <- Directional::dgcpc(u, omega = mu, g = kappa, rho = rho, rads = rads, logden = logden)
  } else if ( type == "cipc" ) {
    den <- Directional::dcipc(u, omega = mu, g = kappa, rads = rads, logden = logden)
  }
  den
}

circda.cv <- function(u, ina, rads = TRUE, folds = NULL, nfolds = 10, stratified = FALSE,
                      type = c("vm", "cp", "pn", "gcpc", "cipc"), seed = NULL) {

  if ( is.null(folds) )  folds <- Directional::makefolds(ina, nfolds = nfolds, stratified = stratified, seed = seed)
  nfolds <- length(folds)

  if ( !rads )  u <- u * pi/180
  per <- matrix(0, nfolds, 5)
  colnames(per) <- c("vM", "cp", "PN", "GCPC", "CIPC")
  for ( i in 1:nfolds ) {
    utrain <- u[ - folds[[ i ]] ]
    utest <- u[ folds[[ i ]] ]
    inatrain <- ina[ - folds[[ i ]] ]
    inatest <- ina[ folds[[ i ]] ]
    est <- circda::circ.da(utest, utrain, inatrain, rads = TRUE, type = type)
    per[i, ] <- Rfast::colmeans( est == inatest )
  }

  perf <- Rfast::colmeans(per)
  names(perf) <- colnames(per)
  perf
}

mix.circplot <- function(u, ina, mu, rads = TRUE, lwd = 2) {
  if ( !rads )  u <- u * pi / 180
  dat <- circular::circular(u)
  cx <- cos(mu)  ;  cy <- sin(mu)
  k <- length(mu)
  plot(dat[ina == 1], stack = TRUE)
  arrows(x0 = 0, y0 = 0, x1 = cx[1], y1 = cy[1], length = 0.10, lwd = lwd, col = 1)
  for ( i in 2:k ) {
    points(dat[ina == i], stack = TRUE, col = i)
    arrows(x0 = 0, y0 = 0, x1 = cx[i], y1 = cy[i], length = 0.10, lwd = lwd, col = i)
  }

}

circ.mle <- function(u, rads = TRUE, type = "vm", tol = 1e-6, maxiters = 100) {

  if ( !rads )  u <- u * pi / 180
  if ( type == "vm" ) {
    res <- Rfast::vm.mle(u, tol)
  } else if ( type == "cp" ) {
    res <- Directional::purka.mle(u, tol)
  } else if ( type == "pn" ) {
    res <- Directional::spml.mle(u, rads = TRUE, tol)
  } else if ( type == "gcpc" ) {
    res <- Directional::gcpc.mle2(u, rads = TRUE)
  } else if ( type == "cipc" ) {
    res <- Directional::cipc.mle(u, rads = TRUE, tol)
  }
  res
}

bic.mixcirc <- function(u, rads = TRUE, type = "vm", G = 5, tol = 1e-4, maxiters = 500) {

  if ( !rads )  u <- u * pi / 180

  if ( type == "vm" ) {
    x <- cbind( cos(u), sin(u) )
    res <- Directional::bic.mixvmf(x, G, n.start = 10, tol = tol, maxiters = maxiters)
  } else if ( type == "cp" ) {
    res <- .bic.mixpurka(u,  G, tol, maxiters)
  } else if ( type == "pn" ) {
    res <- .bic.mixpn(u, G, tol, maxiters)
  } else if ( type == "gcpc" ) {
    res <- .bic.mixgcpc(u,  G, tol, maxiters)
  } else if ( type == "cipc" ) {
    x <- cbind( cos(u), sin(u) )
    res <- Directional::bic.mixspcauchy(x, G = G, n.start = 10, tol = tol, maxiters = maxiters)
  }

  res
}


.bic.mixpurka <- function(u, G = 5, tol = 1e-4, maxiters = 100) {
  runtime <- proc.time()
  logn <- log( length(u) )  ## sample size of the data
  bic <- icl <- 1:G
  mod <- Directional::purka.mle(u)
  bic[1] <- icl[1] <-  - 2 * mod$loglik + 2 * logn  ## BIC assuming one cluster

  for ( vim in 2:G ) {
    a <- .mixpurka.mle(u, rads = TRUE, vim, tol = tol, maxiters = maxiters)
    d <- dim(a$param)[1]
    tab <- table(a$pred)
    nm <- min( tab )
    if ( d == vim  &  d == length(tab)  &  nm >= 6 ) {
      bic[vim] <-  - 2 * a$loglik + ( d - 1 + 2 * d ) * logn
      icl[vim] <- bic[vim] - 2 * sum( a$probs * log(a$probs), na.rm = TRUE )
    } else  {
      bic[vim] <- bic[vim - 1]
      icl[vim] <- icl[vim - 1]
    }
  }  ## BIC for a range of different clusters

  runtime <- proc.time() - runtime
  names(bic) <- names(icl) <- paste("g=", 1:G, sep = "")
  ina <- rep(1, G)
  char <- rep(16, G)
  ina[ which.min(icl) ] <- 3  ## chosen number of clusters will appear with red on the plot
  char[ which.min(icl) ] <- 17
  plot(1:G, icl, col = ina, xlab = "Number of components", ylab = "ICL values", cex.lab = 1.3, cex.axis = 1.3)
  abline(v = 1:G, lty = 2, col = "lightgrey")
  abline(h = seq(min(icl, na.rm = FALSE), max(icl, na.rm = FALSE), length = 10), lty = 2, col = "lightgrey" )
  lines(1:G, icl, lwd = 2)
  abline(v = which.min(icl), col = 3, lwd = 2)
  points(1:G, icl, pch = char, col = ina)
  list(bic = bic, icl = icl, runtime = runtime)
}


.bic.mixpn <- function(u, G = 5, tol = 1e-4, maxiters = 100) {
  runtime <- proc.time()
  logn <- log( length(u) )  ## sample size of the data
  bic <- icl <- 1:G
  mod <- Directional::spml.mle(u, rads = TRUE)
  bic[1] <- icl[1] <-  - 2 * mod$loglik + 2 * logn  ## BIC assuming one cluster

  for ( vim in 2:G ) {
    a <- .mixpn.mle(u, rads = TRUE, vim, tol = tol)  ## model based clustering for some possible clusters
    if ( sum( is.na(a$param) ) == 0 ) {
      d <- dim(a$param)[1]
      tab <- table(a$pred)
      nm <- min(tab)
      if ( d == vim  &  d == length(tab)  &  nm >= 6 ) {
        bic[vim] <-  - 2 * a$loglik + ( d - 1 + 2 * d ) * logn
        icl[vim] <- bic[vim] - 2 * sum( a$probs * log(a$probs), na.rm = TRUE )
      } else  {
        bic[vim] <- bic[vim - 1]
        icl[vim] <- icl[vim - 1]
      }
    } else {
      bic[vim] <- bic[vim - 1]
      icl[vim] <- icl[vim - 1]
    }
  }  ## BIC for a range of different clusters

  runtime <- proc.time() - runtime
  names(bic) <- names(icl) <- paste("g=", 1:G, sep = "")
  ina <- rep(1, G)
  char <- rep(16, G)
  ina[ which.min(icl) ] <- 3  ## chosen number of clusters will appear with red on the plot
  char[ which.min(icl) ] <- 17
  plot(1:G, icl, col = ina, xlab = "Number of components", ylab = "ICL values", cex.lab = 1.3, cex.axis = 1.3)
  abline(v = 1:G, lty = 2, col = "lightgrey")
  abline(h = seq(min(icl, na.rm = FALSE), max(icl, na.rm = FALSE), length = 10), lty = 2, col = "lightgrey" )
  lines(1:G, icl, lwd = 2)
  abline(v = which.min(icl), col = 3, lwd = 2)
  points(1:G, icl, pch = char, col = ina)
  list(bic = bic, icl = icl, runtime = runtime)
}



.bic.mixgcpc <- function(u, G = 5, tol = 1e-4, maxiters = 100) {
  runtime <- proc.time()
  logn <- log( length(u) )
  bic <- icl <- 1:G
  mod <- Directional::gcpc.mle2(u, rads = TRUE)
  bic[1] <- icl[1] <-  - 2 * mod$loglik + 3 * logn  ## BIC assuming one cluster

  for ( vim in 2:G ) {
    a <- .mixgcpc.mle(u, rads = TRUE, vim, tol = tol, maxiters = 100)
    d <- dim(a$param)[1]
    tab <- table(a$pred)
    nm <- min( tab )
    if ( d == vim  &  d == length(tab)  &  nm >= 6 ) {
      bic[vim] <-  - 2 * a$loglik + ( d - 1 + 3 * d ) * logn
      icl[vim] <- bic[vim] - 2 * sum( a$probs * log(a$probs), na.rm = TRUE )
    } else  {
      bic[vim] <- bic[vim - 1]
      icl[vim] <- icl[vim - 1]
    }
  }  ## BIC for a range of different clusters

  runtime <- proc.time() - runtime
  names(bic) <- names(icl) <- paste("g=", 1:G, sep = "")
  ina <- rep(1, G)
  char <- rep(16, G)
  ina[ which.min(icl) ] <- 3  ## chosen number of clusters will appear with red on the plot
  char[ which.min(icl) ] <- 17
  plot(1:G, icl, col = ina, xlab = "Number of components", ylab = "ICL values", cex.lab = 1.3, cex.axis = 1.3)
  abline(v = 1:G, lty = 2, col = "lightgrey")
  abline(h = seq(min(icl, na.rm = FALSE), max(icl, na.rm = FALSE), length = 10), lty = 2, col = "lightgrey" )
  lines(1:G, icl, lwd = 2)
  abline(v = which.min(icl), col = 3, lwd = 2)
  points(1:G, icl, pch = char, col = ina)
  list(bic = bic, icl = icl, runtime = runtime)
}

\name{circda-package}
\alias{circda-package}
\docType{package}
\title{
Circular Data Analysis
}

\description{
Functions to perform maximum likelihood estimation, model-based clustering,
discriminant and regression analysis with a circular response variable.
}

\details{
\tabular{ll}{
Package: \tab circda\cr
Type: \tab Package\cr
Version: \tab 1.0 \cr
Date: \tab 2026-07-20 \cr
}
}

\author{
Michail Tsagris \email{mtsagris@uoc.gr}
}

\section{Maintainers}{
Michail Tsagris <mtsagris@uoc.gr>.
}

\references{
Scealy J.L. and Wood A.T.A. (2019). Scaled von Mises-Fisher distributions and regression models for paleomagnetic directional data.
Journal of the American Statistical Association, 114(528):  1547--1560.
}

\name{mixcirc.mle}
\alias{mixcirc.mle}
\title{
Fitting mixtures of circular distributions
}

\description{
Fitting mixtures of circular distributions.
}

\usage{
mixcirc.mle(u, type ="vm", rads = TRUE, g = 2, tol = 1e-4, maxiters = 500)
}

\arguments{
\item{u}{
A vector with the circular data expressed in radians, or angles.
}
\item{type}{
The distribution to fit, "vm" is von Mises mixtures, "cp" is circular Purkayastha mixtures,
"pn" is projected normal mixtures, "gcpc" is GCPC mixtures and "cipc" is CIPC
(or wrapped Caucy) mixtures.
}
\item{rads}{
If the data are expressed in angles set this to FALSE.
}
\item{g}{
The number of groups to fit. It must be greater than or equal to 2.
}
\item{tol}{
The tolerance value to terminate the EM algorithm.
}
\item{maxiters}{
The maximum number of iterations the EM algorithm will perform.
}
}

\details{
The functions performs model-based clustering using mixtures of circular distributions.
The initial step of the algorithm is based on the k-means algorithm.
}

\value{
A list including:
\item{param}{
A matrix with the mixing probability of each group and the estimated parameters of
the chosen distribution.
}
\item{loglik}{
The value of the maximised log-likelihood of the chosen distribution.
}
\item{probs}{
The estimated probabilities of each observation to belong to each cluster.
}
\item{pred}{
The predicted group of each observation.
}
\item{iter}{
The number of iteration required by the EM algorithm.
}
\item{runtime}{
The run time of the algorithm. A numeric vector. The first element is the user time, the second element is the system time and the third element is the elapsed time.
}
}

\references{
Perdikis T., Alharbi N. and Tsagris M. (2026). Model--based clustering for spherical
and hyper--spherical data using elliptically symmetric distributions.

https://arxiv.org/abs/2605.27496
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}
%\note{
%%  ~~further notes~~
%}
\seealso{
\code{\link{bic.mixcirc}
}
}

\examples{
u1 <- rnorm(100)
u2 <- rnorm(100, 1, 0.5)
u <- c(u1, u2)
mixcirc.mle(u, type = "vm")
}

\name{circ.mle}
\alias{circ.mle}
\title{
MLE of a circular distribution
}

\description{
MLE of a circular distribution.
}

\usage{
circ.mle(u, rads = TRUE, type ="vm", tol = 1e-6, maxiters = 100)
}

\arguments{
\item{u}{
A vector with the circular data expressed in radians, or angles.
}
\item{rads}{
If the data are expressed in angles set this to FALSE.
}
\item{type}{
The distribution to fit, "vm" is von Mises distribution, "cp" is the circular Purkayastha distribution,
"pn" is projected normal distribution, "gcpc" is GCPC distribution and "cipc" is CIPC
(or wrapped Caucy) distribution.
}
\item{tol}{
The tolerance value to terminate the Newton-Raphson algorithm.
}
\item{maxiters}{
The maximum number of iterations the Newton-Raphson algorithm will perform.
}
}

\details{
The function performs MLE of circular distributions.
}

\value{
A list including:
\item{param}{
A matrix with the mixing probability of each group and the estimated parameters of
the chosen distribution.
}
\item{loglik}{
The value of the maximised log-likelihood of the chosen distribution.
}
\item{iter}{
The number of iteration required by the EM algorithm.
}
\item{runtime}{
The run time of the algorithm. A numeric vector. The first element is the user time, the second element is the system time and the third element is the elapsed time.
}
}

\references{
Mardia K. V. and Jupp P. E. (2000). Directional statistics. Chicester: John Wiley & Sons.

Sra S. (2012). A short note on parameter approximation for von Mises-Fisher distributions:
and a fast implementation of \eqn{I_s(x)}. Computational Statistics, 27(1): 177--190.

Presnell Brett, Morrison Scott P. and Littell Ramon C. (1998). Projected multivariate linear models for directional data. Journal of the American Statistical Association, 93(443): 1068--1077.

Tsagris M. and Alzeley O. (2025). Circular and spherical projected Cauchy distributions:
A Novel Framework for Circular and Directional Data Modelling.
Australian & New Zealand Journal of Statistics, 67(1): 77--103.
https://arxiv.org/pdf/2302.02468.pdf

Alzeley O. and Tsagris M. (2026). On the generalized circular projected Cauchy distribution.
Mathematics, 14(11): 1934. https://www.mdpi.com/2227-7390/14/11/1934

Purkayastha S. (1991). A Rotationally Symmetric Directional Distribution: Obtained through Max-
imum Likelihood Characterization. The Indian Journal of Statistics, Series A, 53(1): 70--83.

Cabrera J. and Watson G. S. (1990). On a spherical median related distribution. Communications
in Statistics-Theory and Methods, 19(6): 1973--1986
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}
%\note{
%%  ~~further notes~~
%}
\seealso{
\code{\link{mixcirc.mle}
}
}

\examples{
u <- rcirc(100, mu = 3, kappa = 2, rads = TRUE, type = "vm")
circ.mle(u, rads = TRUE, type = "vm")
}

\name{dirda.cv}
\alias{circda.cv}
\title{
Cross validation for estimating the classification rate
}

\description{
Cross validation for estimating the classification rate.
}

\usage{
circda.cv(u, ina, rads = TRUE, folds = NULL, nfolds = 10, stratified = FALSE,
          type = c("vm", "cp", "pn", "gcpc", "cipc"), seed = NULL)
}

\arguments{
\item{u}{
A numerical vector with the data (expressed in radians, or angles).
}
\item{ina}{
A variable indicating the groupings.
}
\item{rads}{
If the data are expressed in angles set this to FALSE.
}
\item{folds}{
Do you already have a list with the folds? If not, leave this NULL.
}
\item{nfolds}{
How many folds to create?
}
\item{stratified}{
Should the folds be created in a stratified way? i.e. keeping the distribution of the groups
similar through all folds?
}
\item{seed}{
If seed is TRUE, the results will always be the same.
}
\item{type}{
The distribution to fit, "vm" is von Mises distribution, "cp" is the circular Purkayastha distribution,
"pn" is projected normal distribution, "gcpc" is GCPC distribution and "cipc" is CIPC
(or wrapped Caucy) distribution.
}
}

\details{
Cross-validation for the estimation of the performance of a classifier.
}

\value{
A vector with 5 numbers, one for each distribution, containing the percentage of
correct classification. If you chose less distributions to test, the elements of
the non-chosen distributions will contain NAs.
}

\references{
Tsagris M., Papastamoulis P. and Kato S. (2025). Directional data analysis using the spherical Cauchy and the Poisson kernel-based distribution.
Statistics and Computing, 35:51.

Tsagris M. and Alenazi A. (2019). Comparison of discriminant analysis methods on the sphere.
Communications in Statistics: Case Studies, Data Analysis and Applications, 5(4), 467--491.

Mardia K. V. and Jupp, P. E. (2000). Directional statistics. Chicester: John Wiley & Sons.

Morris J. E. and Laycock P. J. (1974). Discriminant analysis of directional data. Biometrika, 61(2): 335--341.
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}
%\note{
  %%  ~~further notes~~
    %}

\seealso{
\code{\link{circ.da}
}
}

\examples{
u1 <- rnorm(50, 3, 0.5)
u2 <- rnorm(50, 3, 0.5)
u <- c(u1, u2)
ina <- rep(1:2, each = 50)
circda.cv(u, ina)
}

\name{circplot}
\alias{circplot}
\title{
Circular histogram
}

\description{
Histogram of circular data.
}

\usage{
circplot(u, mu = NULL, rads = TRUE, col = 3, lwd = 2)
}

\arguments{
\item{u}{
A vector with the circular data expressed in radians, or angles.
}
\item{mu}{
The estimated circular mean or a circular location estimate. If this
is not available the circular mean is caclulated internally.
}
\item{rads}{
If the data are expressed in angles set this to FALSE.
}
\item{col}{
The color of the arrow pointing the mean direction.
}
\item{lwd}{
The thickness of the above arrow of the circular mean.
}
}

%\details{
%}

\value{
A circular histogram.
}

%\references{
%}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}

%\note{
%%  ~~further notes~~
%}

\seealso{
\code{ \link{circ.mle}
}
}

\examples{
u <- rnorm(100, rnorm(3, 0.2) )
circplot(u, 3)
}

\name{circ.reg}
\alias{circ.reg}
\title{
Regression model using a circular distribution
}

\description{
Regression model using a circular distribution.
}

\usage{
circ.reg(y, x, rads = TRUE, type = "vm", xnew = NULL, tol = 1e-6, maxiters = 100)
}

\arguments{
\item{y}{
A vector with the circular data expressed in radians, or angles.
}
\item{x}{
The independent variable(s). Can be Euclidean or categorical (factor variables).
}
\item{rads}{
If the data are expressed in angles set this to FALSE.
}
\item{type}{
The distribution to fit, "vm" is von Mises distribution, "cp" is the circular Purkayastha distribution,
"pn" is projected normal distribution, "gcpc" is GCPC distribution and "cipc" is CIPC
(or wrapped Caucy) distribution.
}
\item{xnew}{
The new values of some independent variable(s) whose circular values you want to predict.
The can be Euclidean or categorical. If you have no new x values, leave it NULL (default).
}
\item{tol}{
The tolerance value to terminate the Newton-Raphson algorithm.
}
\item{maxiters}{
The maximum number of iterations allowed in the Newton-Raphson algorithm.
}
}

\details{
The functions performs regression using circular distributions.
}

\value{
A list including:
\item{param}{
A matrix with the mixing probability of each group and the estimated parameters of
the chosen distribution.
}
\item{loglik}{
The value of the maximised log-likelihood of the chosen distribution.
}
\item{iter}{
The number of iteration required by the EM algorithm.
}
\item{runtime}{
The run time of the algorithm. A numeric vector. The first element is the user time, the second element is the system time and the third element is the elapsed time.
}
}

\references{
Perdikis T., Alharbi N. and Tsagris M. (2026). Model--based clustering for spherical
and hyper--spherical data using elliptically symmetric distributions.

https://arxiv.org/abs/2605.27496
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}
%\note{
%%  ~~further notes~~
%}
\seealso{
\code{\link{circ.regs}
}
}

\examples{
y <- rcirc(100, mu = 3, kappa = 2, rads = TRUE, type = "vm")
x <- rnorm(100)
circ.reg(y, x, rads = TRUE, type = "vm")
}

\name{dmixcirc}
\alias{dmixcirc}
\title{
Density values for mixtures of circular distributions
}

\description{
Density values for mixtures of circular distributions.
}

\usage{
dmixcirc(u, rads = TRUE, probs, mu, kappa, rho, type = "vm", logden = FALSE)
}

\arguments{
\item{u}{
A vector with the values at which the density is to be computed.
}
\item{rads}{
The data that to be generated will be expressed in rads (TRUE) or angles (FALSE)?
}
\item{probs}{
A vector with the mixing probability of each group.
}
\item{mu}{A vector with the circular mean (in radians) of each group.
}
\item{kappa}{
A vector with the concentration parameter of each group.
}
\item{rho}{
A vector with the \eqn{\rho} parameter of the GCPC distribution.
}
\item{type}{
The distribution to fit, "vm" is von Mises mixtures, "cp" is circular Purkayastha mixtures,
"pn" is projected normal mixtures, "gcpc" is GCPC mixtures and "cipc" is CIPC
(or wrapped Caucy) mixtures.
}
\item{logden}{
If you want the log of the density set this equal to TRUE.
}
}

\details{
The function computes the density of a mixture of circular distributions at the given points.
}

\value{
A vector with the density values of a mixture of circular distributions computed at the given points.
}

\references{
Perdikis T., Alharbi N. and Tsagris M. (2026). Model--based clustering for spherical
and hyper--spherical data using elliptically symmetric distributions.

https://arxiv.org/abs/2605.27496
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}
%\note{
%%  ~~further notes~~
%}
\seealso{
\code{\link{mixcirc.mle}
}
}

\examples{
u1 <- rnorm(100)
u2 <- rnorm(100, 1, 0.2)
u <- c(u1, u2)
mod <- mixcirc.mle(u, type = "vm")
f <- dmixcirc(u, rads = TRUE, probs = mod$param[, 1], mu = mod$param[, 2], kappa = mod$param[, 3])
hist(f)
}

\name{bic.mixcirc}
\alias{bic.mixcirc}
\title{
BIC and ICL for the model based clustering with circular distributions
}

\description{
BIC and ICL for the model based clustering with circular distributions.
}

\usage{
bic.mixcirc(u, rads = TRUE, type = "vm", G = 5, tol = 1e-4, maxiters = 500)
}

\arguments{
\item{u}{
A matrix containing directional data.
}
\item{rads}{
If the data are expressed in angles set this to FALSE.
}
\item{type}{
The distribution to fit, "vm" is von Mises mixtures, "cp" is circular Purkayastha mixtures,
"pn" is projected normal mixtures, "gcpc" is GCPC mixtures and "cipc" is CIPC
(or wrapped Caucy) mixtures.
}
\item{G}{
The maximum number of clusters to be tested. Default value is 5.
}
\item{tol}{
The tolerance value to terminate the EM algorithm.
}
\item{maxiters}{
The maximum number of iterations the EM algorithm will perform.
}
}

\details{
The function computes the BIC and ICL to decide on the optimal number of clusters when
using mixtures of SESPC or mixtures of ESAG distributions.
}

\value{
A plot of the ICL values and a list including:
\item{bic}{
The BIC values for all the models tested.
}
\item{icl}{
The ICL values for all the models tested.
}
\item{runtime}{
The run time of the algorithm. A numeric vector. The first element is the user time,
the second element is the system time and the third element is the elapsed time.
}
}

\references{
Perdikis T., Alharbi N. and Tsagris M. (2026). Model--based clustering for spherical
and hyper--spherical data using elliptically symmetric distributions.

https://arxiv.org/abs/2605.27496
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris.
}

%\note{
%%  ~~further notes~~
%}

\seealso{
\code{\link{mixcirc.mle}, \link{circ.mle}
}
}

\examples{
u1 <- rnorm(100, 3, 0.1)
u2 <- rnorm(100, 4, 0.1)
u <- c(u1, u2)
bic.mixcirc(u, type = "vm", G = 5)
}

\name{circ.regs}
\alias{circ.regs}
\title{
Many simple circular regressions
}

\description{
Many simple circular regressions.
}

\usage{
circ.regs(y, x, rads = TRUE, type = "vm", tol = 1e-6, logged = FALSE,
maxiters = 100, ncores = 1)
}

\arguments{
\item{y}{
A vector with the circular data expressed in radians, or angles.
}
\item{x}{
A numerical matrix with many variables. A circular regression will be fit to each of these variables.
}
\item{rads}{
If the data are expressed in angles set this to FALSE.
}
\item{type}{
The distribution to fit, "vm" is von Mises distribution, "cp" is the circular Purkayastha distribution,
"pn" is projected normal distribution, and "cipc" is CIPC (or wrapped Caucy) distribution.
}
\item{tol}{
The tolerance value to terminate the Newton-Raphson algorithm.
}
\item{logged}{
Do you want the logarithm of the p-value to be returned?
}
\item{maxiters}{
The maximum number of iterations the Newton-Raphson algorithm will perform.
}
\item{ncores}{
A number specifying the number of cores to use. If more than 1, then parallel processing is performed.
}
}

\details{
The function performs many regressions with one circular dependent variable and one
Euclidean independent variable. For each colum of x a circular regression model is
fitted and the hypothesis testing of no association between y and this variable is performed.
}

\value{
A matrix with two columns, the test statistics and their associated (log) p-values.
}

\references{
Mardia K. V. and Jupp P. E. (2000). Directional statistics. Chicester: John Wiley & Sons.

Presnell Brett, Morrison Scott P. and Littell Ramon C. (1998). Projected multivariate linear models for directional data. Journal of the American Statistical Association, 93(443): 1068--1077.

Tsagris M. and Alzeley O. (2025). Circular and spherical projected Cauchy distributions:
A Novel Framework for Circular and Directional Data Modelling.
Australian & New Zealand Journal of Statistics, 67(1): 77--103.
https://arxiv.org/pdf/2302.02468.pdf

Purkayastha S. (1991). A Rotationally Symmetric Directional Distribution: Obtained through Max-
imum Likelihood Characterization. The Indian Journal of Statistics, Series A, 53(1): 70--83.
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}
%\note{
%%  ~~further notes~~
%}
\seealso{
\code{\link{circ.reg}
}
}

\examples{
y <- rcirc(100, mu = 3, kappa = 2, rads = TRUE, type = "vm")
x <-  matrix(rnorm(100 * 10), ncol = 10)
circ.regs(y, x, rads = TRUE, type = "vm")
}

\name{circ.da}
\alias{circ.da}
\title{
Prediction of a new observation using discriminant analysis based on circular distributions
}

\description{
Prediction of a new observation using discriminant analysis based on circular distributions.
}

\usage{
circ.da(unew, u, ina, rads = TRUE, type = c("vm", "cp", "pn", "gcpc", "cipc") )
}

\arguments{
\item{unew}{
The new observation(s) (expressed in radians, or angles) whose group is to be predicted.
}
\item{u}{
A numerical vector with the data (expressed in radians, or angles).
}
\item{ina}{
A vector indicating the groups of the data y.
}
\item{rads}{
If the data are expressed in angles set this to FALSE.
}
\item{type}{
The distribution to fit, "vm" is von Mises distribution, "cp" is the circular Purkayastha distribution,
"pn" is projected normal distribution, "gcpc" is GCPC distribution and "cipc" is CIPC
(or wrapped Caucy) distribution.
}
}

\details{
Prediction of the class of a new circular vector assuming some distributions.
}

\value{
A matrix with 5 columns, one for each distribution, where each row contains the predicted class
of each observation If you chose less distributions to test, the columns of the non-chosen
distributions will contain NAs.
}

\references{
Tsagris M. and Alenazi A. (2019). Comparison of discriminant analysis methods on the sphere.
Communications in Statistics: Case Studies, Data Analysis and Applications, 5(4): 467--491.

Tsagris M., Papastamoulis P. and Kato S. (2025). Directional data analysis using the spherical Cauchy and the Poisson kernel-based distribution.
Statistics and Computing, 35:51.

Morris J. E. and Laycock P. J. (1974). Discriminant analysis of directional data. Biometrika, 61(2): 335--341.

Mardia K. V. and Jupp P. E. (2000). Directional statistics. Chicester: John Wiley & Sons.

}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}
%\note{
  %%  ~~further notes~~
    %}

\seealso{
\code{\link{circda.cv}
}
}

\examples{
u1 <- rnorm(50, 3, 0.2)
u2 <- rnorm(50, 5, 0.4)
u <- c(u1, u2)
ina <- rep(1:2, each = 50)
est <- circ.da(u, u, ina)
}

\name{mix.circplot}
\alias{mix.circplot}
\title{
Circular histogram
}

\description{
Histogram of circular data.
}

\usage{
mix.circplot(u, ina, mu, rads = TRUE, lwd = 2)
}

\arguments{
\item{u}{
A vector with the circular data expressed in radians, or angles.
}
\item{ina}{
A numeric vector indicating the groups of the data.
}
\item{mu}{
The estimated circular mean or a circular location estimate. If this
is not available the circular mean is caclulated internally.
}
\item{rads}{
If the data are expressed in angles set this to FALSE.
}
\item{lwd}{
The thickness of the above arrow of the circular means.
}
}

%\details{
%}

\value{
A circular histogram ith different colours for each group and each circular mean.
}

%\references{
%}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}

%\note{
%%  ~~further notes~~
%}

\seealso{
\code{ \link{circplot}
}
}

\examples{
u <- c( rnorm(50, 1, 0.3 ), rnorm(50, 2, 0.5 ) )
ina <- rep(1:2, each = 50)
mix.circplot(u, ina = ina, mu = c(1, 3) )
}

\name{rcirc}
\alias{rcirc}
\title{
Random value generation from circular distributions
}

\description{
Random value generation from circular distributions.
}

\usage{
rcirc(n, rads = TRUE, mu, kappa, rho, type = "vm")
}

\arguments{
\item{n}{
The sample size.
}
\item{rads}{
The data that to be generated will be expressed in rads (TRUE) or angles (FALSE)?
}
\item{mu}{A vector with the circular mean or location parameter (in radians).
}
\item{kappa}{
A vector with the concentration parameter.
}
\item{rho}{
A vector with the \eqn{\rho} parameter of the GCPC distribution.
}
\item{type}{
The distribution to fit, "vm" is von Mises distribution, "cp" is the circular Purkayastha distribution,
"pn" is projected normal distribution, "gcpc" is GCPC distribution and "cipc" is CIPC
(or wrapped Caucy) distribution.
}
}

\details{
The function simulates random values simulation from a given circular distribution.
}

\value{
A vector with the simulated data.
}

\references{
Perdikis T., Alharbi N. and Tsagris M. (2026). Model--based clustering for spherical
and hyper--spherical data using elliptically symmetric distributions.

https://arxiv.org/abs/2605.27496
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}
%\note{
  %%  ~~further notes~~
    %}
\seealso{
\code{\link{circ.mle}, \link{rmixcirc}
}
}

\examples{
u <- rcirc(100, mu = 3, kappa = 2, rads = TRUE, type = "vm")
circ.mle(u, rads = TRUE, type = "vm")
}

\name{colcirc.mle}
\alias{colcirc.mle}
\title{
Column-wise MLE of some circular distributions
}

\description{
Column-wise MLE of some circular distributions.
}

\usage{
colcirc.mle(u, rads = TRUE, type = "vm", tol = 1e-07, maxiters = 100, parallel = FALSE)
}

\arguments{
\item{u}{
A numerical matrix with the circular data.
}
\item{rads}{
If the data are expressed in angles set this to FALSE.
}
\item{type}{
The distribution to fit, "vm" is von Mises distribution, "cp" is the circular Purkayastha distribution,
"pn" is projected normal distribution, "gcpc" is GCPC distribution and "cipc" is CIPC
(or wrapped Caucy) distribution.
}
\item{tol}{
The tolerance level to stop the iterative process of finding the MLEs.
}
\item{maxiters}{
The maximum number of iterations to implement. This is for the "spml" only.
}
\item{parallel}{
Should the computations take place in parallel? This is for the "spml" only.
}
}

\details{
The function performs MLE of circular distributions for each column of a matrix.
}

\value{
A matrix with two, columns. The first one contains the parameters of the distribution
and the second columns contains the log-likelihood values.
}

\references{
Mardia K. V. and Jupp P. E. (2000). Directional statistics. Chicester: John Wiley & Sons.

Sra S. (2012). A short note on parameter approximation for von Mises-Fisher distributions:
and a fast implementation of \eqn{I_s(x)}. Computational Statistics, 27(1): 177--190.

Presnell Brett, Morrison Scott P. and Littell Ramon C. (1998). Projected multivariate linear models for directional data. Journal of the American Statistical Association, 93(443): 1068--1077.

Tsagris M. and Alzeley O. (2025). Circular and spherical projected Cauchy distributions:
A Novel Framework for Circular and Directional Data Modelling.
Australian & New Zealand Journal of Statistics, 67(1): 77--103.
https://arxiv.org/pdf/2302.02468.pdf

Alzeley O. and Tsagris M. (2026). On the generalized circular projected Cauchy distribution.
Mathematics, 14(11): 1934. https://www.mdpi.com/2227-7390/14/11/1934

Purkayastha S. (1991). A Rotationally Symmetric Directional Distribution: Obtained through Max-
imum Likelihood Characterization. The Indian Journal of Statistics, Series A, 53(1): 70--83.

Cabrera J. and Watson G. S. (1990). On a spherical median related distribution. Communications
in Statistics-Theory and Methods, 19(6): 1973--1986
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}

%\note{
%%  ~~further notes~~
%}
\seealso{
\code{\link{circ.mle}
}
}

\examples{
u <- matrix( circda::rcirc(200 * 10, mu = 3, kappa = 5), ncol = 10 )
res <- colcirc.mle(u)
}

\name{dcirc}
\alias{dcirc}
\title{
Density values for circular distributions
}

\description{
Density values for circular distributions.
}

\usage{
dcirc(u, rads = TRUE, mu, kappa, rho, type = "vm", logden = FALSE)
}

\arguments{
\item{u}{
A vector with the values at which the density is to be computed.
}
\item{rads}{
The data are expressed in rads (TRUE) or angles (FALSE)?
}
\item{mu}{A vector with the circular mean (in radians).
}
\item{kappa}{
A vector with the concentration parameter.
}
\item{rho}{
A vector with the \eqn{\rho} parameter of the GCPC distribution.
}
\item{type}{
The distribution to fit, "vm" is von Mises distribution, "cp" is the circular Purkayastha distribution,
"pn" is projected normal distribution, "gcpc" is GCPC distribution and "cipc" is CIPC
(or wrapped Caucy) distribution.
}
\item{logden}{
If you want the log of the density set this equal to TRUE.
}
}

\details{
The function computes the density of a given circular distribution at the given points.
}

\value{
A vector with the density values of the circular distribution computed at the given points.
}

\references{
Perdikis T., Alharbi N. and Tsagris M. (2026). Model--based clustering for spherical
and hyper--spherical data using elliptically symmetric distributions.

https://arxiv.org/abs/2605.27496
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}
%\note{
%%  ~~further notes~~
%}
\seealso{
\code{\link{rcirc}
}
}

\examples{
u <- rcirc(100, mu = 3, kappa = 2, rads = TRUE, type = "vm")
mod <- circ.mle(u, rads = TRUE, type = "vm")
f <- dcirc(u, rads = TRUE, mu = mod$param[1], kappa = mod$param[2], logden = TRUE)
sum(f)
}

\name{rmixcirc}
\alias{rmixcirc}
\title{
Random value generation from mixtures of circular distributions
}

\description{
Random value generation from mixtures of circular distributions.
}

\usage{
rmixcirc(n, rads = TRUE, probs, mu, kappa, rho, type = "vm")
}

\arguments{
\item{n}{
The sample size.
}
\item{rads}{
The data that to be generated will be expressed in rads (TRUE) or angles (FALSE)?
}
\item{probs}{
A vector with the mixing probability of each group.
}
\item{mu}{A vector with the circular mean or location parameter (in radians) of each group.
}
\item{kappa}{
A vector with the concentration parameter of each group.
}
\item{rho}{
A vector with the \eqn{\rho} parameter of the GCPC distribution.
}
\item{type}{
The distribution to fit, "vm" is von Mises mixtures, "cp" is circular Purkayastha mixtures,
"pn" is projected normal mixtures, "gcpc" is GCPC mixtures and "cipc" is CIPC
(or wrapped Caucy) mixtures.
}
}

\details{
The function simulates random values simulation from a given mixture of circular distributions.
}

\value{
A list including:
\item{id}{
An indicator of the group of each simulated vector.
}
\item{u}{
A vector with the simulated data.
}
}

\references{
Perdikis T., Alharbi N. and Tsagris M. (2026). Model--based clustering for spherical
and hyper--spherical data using elliptically symmetric distributions.

https://arxiv.org/abs/2605.27496
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}
%\note{
%%  ~~further notes~~
%}
\seealso{
\code{\link{mixcirc.mle}
}
}

\examples{
u1 <- rnorm(100)
u2 <- rnorm(100, 1, 0.5)
u <- c(u1, u2)
mod <- mixcirc.mle(u, type = "vm")
y <- rmixcirc(500, rads = TRUE, probs = mod$param[, 1], mu = mod$param[, 2], kappa = mod$param[, 3])
hist(y$u)
}
